# azure_mgmt_containerregistry crate

The is an [Azure SDK for Rust](https://github.com/Azure/azure-sdk-for-rust) crate that is generated from the Azure REST API specifications listed in:

https://github.com/Azure/azure-rest-api-specs/blob/main/specification/containerregistry/resource-manager/readme.md

The default `Tag` is `package-2021-12-preview`.

The following `Tag`s are available:

- `package-2021-12-preview-only` has 60 operations from 1 API versions: `2021-12-01-preview`. Use crate feature `package-2021-12-preview-only` to enable. The operations will be in the `package_2021_12_preview_only` module.
- `package-2021-12-preview` has 85 operations from 2 API versions: `2019-06-01-preview`, `2021-12-01-preview`. Use crate feature `package-2021-12-preview` to enable. The operations will be in the `package_2021_12_preview` module.
- `package-2021-09-only` has 31 operations from 1 API versions: `2021-09-01`. Use crate feature `package-2021-09-only` to enable. The operations will be in the `package_2021_09_only` module.
- `package-2021-09` has 56 operations from 2 API versions: `2019-06-01-preview`, `2021-09-01`. Use crate feature `package-2021-09` to enable. The operations will be in the `package_2021_09` module.
- `package-2021-08-preview-only` has 59 operations from 1 API versions: `2021-08-01-preview`. Use crate feature `package-2021-08-preview-only` to enable. The operations will be in the `package_2021_08_preview_only` module.
- `package-2021-08-preview` has 84 operations from 2 API versions: `2019-06-01-preview`, `2021-08-01-preview`. Use crate feature `package-2021-08-preview` to enable. The operations will be in the `package_2021_08_preview` module.
- `package-2021-06-preview-only` has 59 operations from 1 API versions: `2021-06-01-preview`. Use crate feature `package-2021-06-preview-only` to enable. The operations will be in the `package_2021_06_preview_only` module.
- `package-2021-06-preview` has 84 operations from 2 API versions: `2019-06-01-preview`, `2021-06-01-preview`. Use crate feature `package-2021-06-preview` to enable. The operations will be in the `package_2021_06_preview` module.
- `package-2020-11-preview-only` has 59 operations from 1 API versions: `2020-11-01-preview`. Use crate feature `package-2020-11-preview-only` to enable. The operations will be in the `package_2020_11_preview_only` module.
- `package-2020-11-preview` has 84 operations from 2 API versions: `2019-06-01-preview`, `2020-11-01-preview`. Use crate feature `package-2020-11-preview` to enable. The operations will be in the `package_2020_11_preview` module.
- `package-2019-12-preview-only` has 42 operations from 1 API versions: `2019-12-01-preview`. Use crate feature `package-2019-12-preview-only` to enable. The operations will be in the `package_2019_12_preview_only` module.
- `package-2019-12-preview` has 78 operations from 3 API versions: `2019-05-01-preview`, `2019-06-01-preview`, `2019-12-01-preview`. Use crate feature `package-2019-12-preview` to enable. The operations will be in the `package_2019_12_preview` module.
- `package-2019-06-preview` has 61 operations from 3 API versions: `2019-05-01`, `2019-05-01-preview`, `2019-06-01-preview`. Use crate feature `package-2019-06-preview` to enable. The operations will be in the `package_2019_06_preview` module.
- `package-2019-06-preview-only` has 25 operations from 1 API versions: `2019-06-01-preview`. Use crate feature `package-2019-06-preview-only` to enable. The operations will be in the `package_2019_06_preview_only` module.
- `package-2019-05-only` has 25 operations from 1 API versions: `2019-05-01`. Use crate feature `package-2019-05-only` to enable. The operations will be in the `package_2019_05_only` module.
- `package-2019-05` has 38 operations from 2 API versions: `2019-04-01`, `2019-05-01`. Use crate feature `package-2019-05` to enable. The operations will be in the `package_2019_05` module.
- `package-2019-05-preview-only` has 11 operations from 1 API versions: `2019-05-01-preview`. Use crate feature `package-2019-05-preview-only` to enable. The operations will be in the `package_2019_05_preview_only` module.
- `package-2019-05-preview` has 38 operations from 2 API versions: `2017-10-01`, `2019-05-01-preview`. Use crate feature `package-2019-05-preview` to enable. The operations will be in the `package_2019_05_preview` module.
- `package-2019-04` has 40 operations from 2 API versions: `2017-10-01`, `2019-04-01`. Use crate feature `package-2019-04` to enable. The operations will be in the `package_2019_04` module.
- `package-2019-04-only` has 13 operations from 1 API versions: `2019-04-01`. Use crate feature `package-2019-04-only` to enable. The operations will be in the `package_2019_04_only` module.
- `package-2018-09-only` has 13 operations from 1 API versions: `2018-09-01`. Use crate feature `package-2018-09-only` to enable. The operations will be in the `package_2018_09_only` module.
- `package-2018-09` has 40 operations from 2 API versions: `2017-10-01`, `2018-09-01`. Use crate feature `package-2018-09` to enable. The operations will be in the `package_2018_09` module.
- `package-2018-02-preview-only` has 19 operations from 1 API versions: `2018-02-01-preview`. Use crate feature `package-2018-02-preview-only` to enable. The operations will be in the `package_2018_02_preview_only` module.
- `package-2018-02-preview` has 46 operations from 2 API versions: `2017-10-01`, `2018-02-01-preview`. Use crate feature `package-2018-02-preview` to enable. The operations will be in the `package_2018_02_preview` module.
- `package-2017-10` has 27 operations from 1 API versions: `2017-10-01`. Use crate feature `package-2017-10` to enable. The operations will be in the `package_2017_10` module.
- `package-2017-06-preview` has 24 operations from 1 API versions: `2017-06-01-preview`. Use crate feature `package-2017-06-preview` to enable. The operations will be in the `package_2017_06_preview` module.
- `package-2017-03` has 10 operations from 1 API versions: `2017-03-01`. Use crate feature `package-2017-03` to enable. The operations will be in the `package_2017_03` module.
- `package-2016-06-preview` has 9 operations from 1 API versions: `2016-06-27-preview`. Use crate feature `package-2016-06-preview` to enable. The operations will be in the `package_2016_06_preview` module.