# azure_mgmt_containerservice crate

The is an [Azure SDK for Rust](https://github.com/Azure/azure-sdk-for-rust) crate that is generated from the Azure REST API specifications listed in:

https://github.com/Azure/azure-rest-api-specs/blob/main/specification/containerservice/resource-manager/readme.md

The default `Tag` is `package-2022-01`.

The following `Tag`s are available:

- `package-2022-01` has 44 operations from 1 API versions: `2022-01-01`. Use crate feature `package-2022-01` to enable. The operations will be in the `package_2022_01` module.
- `package-preview-2022-01` has 44 operations from 1 API versions: `2022-01-02-preview`. Use crate feature `package-preview-2022-01` to enable. The operations will be in the `package_preview_2022_01` module.
- `package-preview-2021-11` has 44 operations from 1 API versions: `2021-11-01-preview`. Use crate feature `package-preview-2021-11` to enable. The operations will be in the `package_preview_2021_11` module.
- `package-2021-10` has 44 operations from 1 API versions: `2021-10-01`. Use crate feature `package-2021-10` to enable. The operations will be in the `package_2021_10` module.
- `package-2021-09` has 44 operations from 1 API versions: `2021-09-01`. Use crate feature `package-2021-09` to enable. The operations will be in the `package_2021_09` module.
- `package-2021-08` has 44 operations from 1 API versions: `2021-08-01`. Use crate feature `package-2021-08` to enable. The operations will be in the `package_2021_08` module.
- `package-2021-07` has 38 operations from 1 API versions: `2021-07-01`. Use crate feature `package-2021-07` to enable. The operations will be in the `package_2021_07` module.
- `package-2021-05` has 38 operations from 1 API versions: `2021-05-01`. Use crate feature `package-2021-05` to enable. The operations will be in the `package_2021_05` module.
- `package-2021-03` has 37 operations from 1 API versions: `2021-03-01`. Use crate feature `package-2021-03` to enable. The operations will be in the `package_2021_03` module.
- `package-2021-02` has 34 operations from 1 API versions: `2021-02-01`. Use crate feature `package-2021-02` to enable. The operations will be in the `package_2021_02` module.
- `package-2020-12` has 34 operations from 1 API versions: `2020-12-01`. Use crate feature `package-2020-12` to enable. The operations will be in the `package_2020_12` module.
- `package-2020-11` has 30 operations from 1 API versions: `2020-11-01`. Use crate feature `package-2020-11` to enable. The operations will be in the `package_2020_11` module.
- `package-2020-09` has 42 operations from 4 API versions: `2017-07-01`, `2019-04-30`, `2019-08-01`, `2020-09-01`. Use crate feature `package-2020-09` to enable. The operations will be in the `package_2020_09` module.
- `package-2020-07` has 38 operations from 4 API versions: `2017-07-01`, `2019-04-30`, `2019-08-01`, `2020-07-01`. Use crate feature `package-2020-07` to enable. The operations will be in the `package_2020_07` module.
- `package-2020-06` has 37 operations from 4 API versions: `2017-07-01`, `2019-04-30`, `2019-08-01`, `2020-06-01`. Use crate feature `package-2020-06` to enable. The operations will be in the `package_2020_06` module.
- `package-2020-04` has 33 operations from 4 API versions: `2017-07-01`, `2019-04-30`, `2019-08-01`, `2020-04-01`. Use crate feature `package-2020-04` to enable. The operations will be in the `package_2020_04` module.
- `package-2020-03` has 33 operations from 4 API versions: `2017-07-01`, `2019-04-30`, `2019-08-01`, `2020-03-01`. Use crate feature `package-2020-03` to enable. The operations will be in the `package_2020_03` module.
- `package-2020-02` has 33 operations from 4 API versions: `2017-07-01`, `2019-04-30`, `2019-08-01`, `2020-02-01`. Use crate feature `package-2020-02` to enable. The operations will be in the `package_2020_02` module.
- `package-2020-01` has 33 operations from 4 API versions: `2017-07-01`, `2019-04-30`, `2019-08-01`, `2020-01-01`. Use crate feature `package-2020-01` to enable. The operations will be in the `package_2020_01` module.
- `package-2019-11` has 33 operations from 4 API versions: `2017-07-01`, `2019-04-30`, `2019-08-01`, `2019-11-01`. Use crate feature `package-2019-11` to enable. The operations will be in the `package_2019_11` module.
- `package-2019-10-27-preview` has 33 operations from 4 API versions: `2017-07-01`, `2019-08-01`, `2019-10-27-preview`, `2020-01-01`. Use crate feature `package-2019-10-27-preview` to enable. The operations will be in the `package_2019_10_27_preview` module.
- `package-2019-09-30-preview` has 32 operations from 3 API versions: `2017-07-01`, `2019-08-01`, `2019-09-30-preview`. Use crate feature `package-2019-09-30-preview` to enable. The operations will be in the `package_2019_09_30_preview` module.
- `package-2019-10` has 33 operations from 4 API versions: `2017-07-01`, `2019-04-30`, `2019-08-01`, `2019-10-01`. Use crate feature `package-2019-10` to enable. The operations will be in the `package_2019_10` module.
- `package-2019-08` has 32 operations from 3 API versions: `2017-07-01`, `2019-04-30`, `2019-08-01`. Use crate feature `package-2019-08` to enable. The operations will be in the `package_2019_08` module.
- `package-2019-06` has 31 operations from 3 API versions: `2017-07-01`, `2019-04-30`, `2019-06-01`. Use crate feature `package-2019-06` to enable. The operations will be in the `package_2019_06` module.
- `package-2019-04` has 29 operations from 3 API versions: `2017-07-01`, `2019-04-01`, `2019-04-30`. Use crate feature `package-2019-04` to enable. The operations will be in the `package_2019_04` module.
- `package-2019-02` has 29 operations from 4 API versions: `2017-07-01`, `2017-09-30`, `2018-09-30-preview`, `2019-02-01`. Use crate feature `package-2019-02` to enable. The operations will be in the `package_2019_02` module.
- `package-2018-08-preview` has 25 operations from 4 API versions: `2017-07-01`, `2017-09-30`, `2018-08-01-preview`, `2018-09-30-preview`. Use crate feature `package-2018-08-preview` to enable. The operations will be in the `package_2018_08_preview` module.
- `package-2018-09-30-preview` has 25 operations from 4 API versions: `2017-07-01`, `2017-09-30`, `2018-03-31`, `2018-09-30-preview`. Use crate feature `package-2018-09-30-preview` to enable. The operations will be in the `package_2018_09_30_preview` module.
- `package-2018-03` has 19 operations from 3 API versions: `2017-07-01`, `2017-09-30`, `2018-03-31`. Use crate feature `package-2018-03` to enable. The operations will be in the `package_2018_03` module.
- `package-2017-09` has 14 operations from 3 API versions: `2017-07-01`, `2017-08-31`, `2017-09-30`. Use crate feature `package-2017-09` to enable. The operations will be in the `package_2017_09` module.
- `package-2017-08` has 13 operations from 2 API versions: `2017-07-01`, `2017-08-31`. Use crate feature `package-2017-08` to enable. The operations will be in the `package_2017_08` module.
- `package-2017-07` has 5 operations from 1 API versions: `2017-07-01`. Use crate feature `package-2017-07` to enable. The operations will be in the `package_2017_07` module.
- `package-2022-01-01-only` has 44 operations from 1 API versions: `2022-01-01`. Use crate feature `package-2022-01-01-only` to enable. The operations will be in the `package_2022_01_01_only` module.
- `package-2022-01-02-preview-only` has 44 operations from 1 API versions: `2022-01-02-preview`. Use crate feature `package-2022-01-02-preview-only` to enable. The operations will be in the `package_2022_01_02_preview_only` module.
- `package-2021-11-01-preview-only` has 44 operations from 1 API versions: `2021-11-01-preview`. Use crate feature `package-2021-11-01-preview-only` to enable. The operations will be in the `package_2021_11_01_preview_only` module.
- `package-2021-10-01-only` has 44 operations from 1 API versions: `2021-10-01`. Use crate feature `package-2021-10-01-only` to enable. The operations will be in the `package_2021_10_01_only` module.
- `package-2021-09-01-only` has 44 operations from 1 API versions: `2021-09-01`. Use crate feature `package-2021-09-01-only` to enable. The operations will be in the `package_2021_09_01_only` module.
- `package-2021-08-01-only` has 44 operations from 1 API versions: `2021-08-01`. Use crate feature `package-2021-08-01-only` to enable. The operations will be in the `package_2021_08_01_only` module.
- `package-2021-07-01-only` has 38 operations from 1 API versions: `2021-07-01`. Use crate feature `package-2021-07-01-only` to enable. The operations will be in the `package_2021_07_01_only` module.
- `package-2021-05-01-only` has 38 operations from 1 API versions: `2021-05-01`. Use crate feature `package-2021-05-01-only` to enable. The operations will be in the `package_2021_05_01_only` module.
- `package-2021-03-01-only` has 37 operations from 1 API versions: `2021-03-01`. Use crate feature `package-2021-03-01-only` to enable. The operations will be in the `package_2021_03_01_only` module.
- `package-2021-02-01-only` has 34 operations from 1 API versions: `2021-02-01`. Use crate feature `package-2021-02-01-only` to enable. The operations will be in the `package_2021_02_01_only` module.
- `package-2020-12-01-only` has 34 operations from 1 API versions: `2020-12-01`. Use crate feature `package-2020-12-01-only` to enable. The operations will be in the `package_2020_12_01_only` module.
- `package-2020-11-01-only` has 30 operations from 1 API versions: `2020-11-01`. Use crate feature `package-2020-11-01-only` to enable. The operations will be in the `package_2020_11_01_only` module.
- `package-2020-09-01-only` has 30 operations from 1 API versions: `2020-09-01`. Use crate feature `package-2020-09-01-only` to enable. The operations will be in the `package_2020_09_01_only` module.
- `package-2020-07-01-only` has 26 operations from 1 API versions: `2020-07-01`. Use crate feature `package-2020-07-01-only` to enable. The operations will be in the `package_2020_07_01_only` module.
- `package-2020-06-01-only` has 25 operations from 1 API versions: `2020-06-01`. Use crate feature `package-2020-06-01-only` to enable. The operations will be in the `package_2020_06_01_only` module.
- `package-2020-04-01-only` has 21 operations from 1 API versions: `2020-04-01`. Use crate feature `package-2020-04-01-only` to enable. The operations will be in the `package_2020_04_01_only` module.
- `package-2020-03-01-only` has 21 operations from 1 API versions: `2020-03-01`. Use crate feature `package-2020-03-01-only` to enable. The operations will be in the `package_2020_03_01_only` module.
- `package-2020-02-01-only` has 21 operations from 1 API versions: `2020-02-01`. Use crate feature `package-2020-02-01-only` to enable. The operations will be in the `package_2020_02_01_only` module.
- `package-2020-01-01-only` has 21 operations from 1 API versions: `2020-01-01`. Use crate feature `package-2020-01-01-only` to enable. The operations will be in the `package_2020_01_01_only` module.
- `package-2019-11-01-only` has 21 operations from 1 API versions: `2019-11-01`. Use crate feature `package-2019-11-01-only` to enable. The operations will be in the `package_2019_11_01_only` module.
- `package-2019-10-27-preview-only` has 6 operations from 1 API versions: `2019-10-27-preview`. Use crate feature `package-2019-10-27-preview-only` to enable. The operations will be in the `package_2019_10_27_preview_only` module.
- `package-2019-10-01-only` has 21 operations from 1 API versions: `2019-10-01`. Use crate feature `package-2019-10-01-only` to enable. The operations will be in the `package_2019_10_01_only` module.
- `package-2019-08-01-only` has 20 operations from 1 API versions: `2019-08-01`. Use crate feature `package-2019-08-01-only` to enable. The operations will be in the `package_2019_08_01_only` module.
- `package-2019-06-01-only` has 19 operations from 1 API versions: `2019-06-01`. Use crate feature `package-2019-06-01-only` to enable. The operations will be in the `package_2019_06_01_only` module.
- `package-2019-04-30-only` has 6 operations from 1 API versions: `2019-04-30`. Use crate feature `package-2019-04-30-only` to enable. The operations will be in the `package_2019_04_30_only` module.
- `package-2019-04-01-only` has 17 operations from 1 API versions: `2019-04-01`. Use crate feature `package-2019-04-01-only` to enable. The operations will be in the `package_2019_04_01_only` module.
- `package-2019-02-only` has 17 operations from 1 API versions: `2019-02-01`. Use crate feature `package-2019-02-only` to enable. The operations will be in the `package_2019_02_only` module.
- `package-2018-08-preview-only` has 13 operations from 1 API versions: `2018-08-01-preview`. Use crate feature `package-2018-08-preview-only` to enable. The operations will be in the `package_2018_08_preview_only` module.
- `package-2018-09-preview-only` has 6 operations from 1 API versions: `2018-09-30-preview`. Use crate feature `package-2018-09-preview-only` to enable. The operations will be in the `package_2018_09_preview_only` module.
- `package-2019-09-preview-only` has 6 operations from 1 API versions: `2019-09-30-preview`. Use crate feature `package-2019-09-preview-only` to enable. The operations will be in the `package_2019_09_preview_only` module.
- `package-2018-03-only` has 13 operations from 1 API versions: `2018-03-31`. Use crate feature `package-2018-03-only` to enable. The operations will be in the `package_2018_03_only` module.
- `package-2017-07-only-extended` has 6 operations from 2 API versions: `2017-07-01`, `2019-04-01`. Use crate feature `package-2017-07-only-extended` to enable. The operations will be in the `package_2017_07_only_extended` module.
- `package-2017-08-only` has 8 operations from 1 API versions: `2017-08-31`. Use crate feature `package-2017-08-only` to enable. The operations will be in the `package_2017_08_only` module.
- `package-2017-09-only` has 1 operations from 1 API versions: `2017-09-30`. Use crate feature `package-2017-09-only` to enable. The operations will be in the `package_2017_09_only` module.
- `package-2017-01-only` has 5 operations from 1 API versions: `2017-01-31`. Use crate feature `package-2017-01-only` to enable. The operations will be in the `package_2017_01_only` module.
- `package-2016-09-only` has 5 operations from 1 API versions: `2016-09-30`. Use crate feature `package-2016-09-only` to enable. The operations will be in the `package_2016_09_only` module.
- `package-2016-03-only` has 5 operations from 1 API versions: `2016-03-30`. Use crate feature `package-2016-03-only` to enable. The operations will be in the `package_2016_03_only` module.
- `profile-hybrid-2020-09-01` has 36 operations from 3 API versions: `2017-07-01`, `2019-04-01`, `2020-11-01`. Use crate feature `profile-hybrid-2020-09-01` to enable. The operations will be in the `profile_hybrid_2020_09_01` module.