# azure_mgmt_monitor crate

The is an [Azure SDK for Rust](https://github.com/Azure/azure-sdk-for-rust) crate that is generated from the Azure REST API specifications listed in:

https://github.com/Azure/azure-rest-api-specs/blob/main/specification/monitor/resource-manager/readme.md

The default `Tag` is `package-2021-09-01-only`.

The following `Tag`s are available:

- `package-2021-09-01-only` has 9 operations from 1 API versions: `2021-09-01`. Use crate feature `package-2021-09-01-only` to enable. The operations will be in the `package_2021_09_01_only` module.
- `package-2021-08` has 6 operations from 1 API versions: `2021-08-01`. Use crate feature `package-2021-08` to enable. The operations will be in the `package_2021_08` module.
- `package-2021-07-01-preview-only` has 17 operations from 1 API versions: `2021-07-01-preview`. Use crate feature `package-2021-07-01-preview-only` to enable. The operations will be in the `package_2021_07_01_preview_only` module.
- `package-2021-04` has 95 operations from 13 API versions: `2015-04-01`, `2016-03-01`, `2017-04-01`, `2017-05-01-preview`, `2017-12-01-preview`, `2018-01-01`, `2018-03-01`, `2018-04-16`, `2018-11-27-preview`, `2019-03-01`, `2019-06-01`, `2019-10-17-preview`, `2021-04-01`. Use crate feature `package-2021-04` to enable. The operations will be in the `package_2021_04` module.
- `package-2021-05-only` has 6 operations from 1 API versions: `2021-05-01`. Use crate feature `package-2021-05-only` to enable. The operations will be in the `package_2021_05_only` module.
- `package-2021-05-01-preview-only` has 21 operations from 1 API versions: `2021-05-01-preview`. Use crate feature `package-2021-05-01-preview-only` to enable. The operations will be in the `package_2021_05_01_preview_only` module.
- `package-2021-04-only` has 17 operations from 1 API versions: `2021-04-01`. Use crate feature `package-2021-04-only` to enable. The operations will be in the `package_2021_04_only` module.
- `package-2021-02-preview-only` has 6 operations from 1 API versions: `2021-02-01-preview`. Use crate feature `package-2021-02-preview-only` to enable. The operations will be in the `package_2021_02_preview_only` module.
- `package-2020-10-only` has 6 operations from 1 API versions: `2020-10-01`. Use crate feature `package-2020-10-only` to enable. The operations will be in the `package_2020_10_only` module.
- `package-2020-05-preview-only` has 6 operations from 1 API versions: `2020-05-01-preview`. Use crate feature `package-2020-05-preview-only` to enable. The operations will be in the `package_2020_05_preview_only` module.
- `package-2020-01-01-preview-only` has 4 operations from 1 API versions: `2020-01-01-preview`. Use crate feature `package-2020-01-01-preview-only` to enable. The operations will be in the `package_2020_01_01_preview_only` module.
- `package-2020-03` has 78 operations from 12 API versions: `2015-04-01`, `2016-03-01`, `2017-04-01`, `2017-05-01-preview`, `2017-12-01-preview`, `2018-01-01`, `2018-03-01`, `2018-04-16`, `2018-11-27-preview`, `2019-03-01`, `2019-06-01`, `2019-10-17-preview`. Use crate feature `package-2020-03` to enable. The operations will be in the `package_2020_03` module.
- `package-2019-11` has 82 operations from 12 API versions: `2015-04-01`, `2016-03-01`, `2017-04-01`, `2017-05-01-preview`, `2017-12-01-preview`, `2018-01-01`, `2018-03-01`, `2018-04-16`, `2018-11-27-preview`, `2019-03-01`, `2019-06-01`, `2019-10-17-preview`. Use crate feature `package-2019-11` to enable. The operations will be in the `package_2019_11` module.
- `package-2019-10-17-preview-only` has 17 operations from 1 API versions: `2019-10-17-preview`. Use crate feature `package-2019-10-17-preview-only` to enable. The operations will be in the `package_2019_10_17_preview_only` module.
- `package-2019-07-only` has 2 operations from 1 API versions: `2019-07-01`. Use crate feature `package-2019-07-only` to enable. The operations will be in the `package_2019_07_only` module.
- `package-2019-06` has 61 operations from 11 API versions: `2015-04-01`, `2016-03-01`, `2017-04-01`, `2017-05-01-preview`, `2017-12-01-preview`, `2018-01-01`, `2018-03-01`, `2018-04-16`, `2018-11-27-preview`, `2019-03-01`, `2019-06-01`. Use crate feature `package-2019-06` to enable. The operations will be in the `package_2019_06` module.
- `package-2019-03` has 61 operations from 10 API versions: `2015-04-01`, `2016-03-01`, `2017-04-01`, `2017-05-01-preview`, `2017-12-01-preview`, `2018-01-01`, `2018-03-01`, `2018-04-16`, `2018-11-27-preview`, `2019-03-01`. Use crate feature `package-2019-03` to enable. The operations will be in the `package_2019_03` module.
- `package-2018-11-preview` has 62 operations from 11 API versions: `2015-04-01`, `2016-03-01`, `2017-04-01`, `2017-05-01-preview`, `2017-11-01-preview`, `2017-12-01-preview`, `2018-01-01`, `2018-03-01`, `2018-04-16`, `2018-09-01`, `2018-11-27-preview`. Use crate feature `package-2018-11-preview` to enable. The operations will be in the `package_2018_11_preview` module.
- `package-2018-09` has 61 operations from 9 API versions: `2015-04-01`, `2016-03-01`, `2017-04-01`, `2017-05-01-preview`, `2017-11-01-preview`, `2018-01-01`, `2018-03-01`, `2018-04-16`, `2018-09-01`. Use crate feature `package-2018-09` to enable. The operations will be in the `package_2018_09` module.
- `package-2018-03` has 60 operations from 8 API versions: `2015-04-01`, `2016-03-01`, `2017-04-01`, `2017-05-01-preview`, `2017-11-01-preview`, `2018-01-01`, `2018-03-01`, `2018-04-16`. Use crate feature `package-2018-03` to enable. The operations will be in the `package_2018_03` module.
- `package-2018-02-preview` has 46 operations from 6 API versions: `2015-04-01`, `2016-03-01`, `2017-04-01`, `2017-05-01-preview`, `2017-11-01-preview`, `2018-01-01`. Use crate feature `package-2018-02-preview` to enable. The operations will be in the `package_2018_02_preview` module.
- `package-2017-12` has 46 operations from 5 API versions: `2015-04-01`, `2016-03-01`, `2017-04-01`, `2017-05-01-preview`, `2017-11-01-preview`. Use crate feature `package-2017-12` to enable. The operations will be in the `package_2017_12` module.
- `package-2017-09` has 46 operations from 6 API versions: `2015-04-01`, `2016-03-01`, `2017-04-01`, `2017-05-01-preview`, `2017-11-01-preview`, `2018-09-01`. Use crate feature `package-2017-09` to enable. The operations will be in the `package_2017_09` module.
- `package-2017-09-preview-only` has 3 operations from 1 API versions: `2017-09-01-preview`. Use crate feature `package-2017-09-preview-only` to enable. The operations will be in the `package_2017_09_preview_only` module.
- `package-2017-08` has 39 operations from 4 API versions: `2015-04-01`, `2016-03-01`, `2017-04-01`, `2017-05-01-preview`. Use crate feature `package-2017-08` to enable. The operations will be in the `package_2017_08` module.
- `package-2019-11-01-preview-only` has 11 operations from 1 API versions: `2019-11-01-preview`. Use crate feature `package-2019-11-01-preview-only` to enable. The operations will be in the `package_2019_11_01_preview_only` module.
- `package-2019-06-01-only` has 7 operations from 1 API versions: `2019-06-01`. Use crate feature `package-2019-06-01-only` to enable. The operations will be in the `package_2019_06_01_only` module.
- `package-2019-03-01-only` has 8 operations from 1 API versions: `2019-03-01`. Use crate feature `package-2019-03-01-only` to enable. The operations will be in the `package_2019_03_01_only` module.
- `package-2018-11-27-preview-only` has 1 operations from 1 API versions: `2018-11-27-preview`. Use crate feature `package-2018-11-27-preview-only` to enable. The operations will be in the `package_2018_11_27_preview_only` module.
- `package-2018-09-01-only` has 10 operations from 1 API versions: `2018-09-01`. Use crate feature `package-2018-09-01-only` to enable. The operations will be in the `package_2018_09_01_only` module.
- `package-2018-06-01-preview-only` has 12 operations from 1 API versions: `2018-06-01-preview`. Use crate feature `package-2018-06-01-preview-only` to enable. The operations will be in the `package_2018_06_01_preview_only` module.
- `package-2018-04-16-only` has 6 operations from 1 API versions: `2018-04-16`. Use crate feature `package-2018-04-16-only` to enable. The operations will be in the `package_2018_04_16_only` module.
- `package-2018-03-01-only` has 15 operations from 2 API versions: `2016-03-01`, `2018-03-01`. Use crate feature `package-2018-03-01-only` to enable. The operations will be in the `package_2018_03_01_only` module.
- `package-2018-01-01-only` has 2 operations from 1 API versions: `2018-01-01`. Use crate feature `package-2018-01-01-only` to enable. The operations will be in the `package_2018_01_01_only` module.
- `package-2017-12-01-preview-only` has 1 operations from 1 API versions: `2017-12-01-preview`. Use crate feature `package-2017-12-01-preview-only` to enable. The operations will be in the `package_2017_12_01_preview_only` module.
- `package-2017-11-01-preview-only` has 2 operations from 1 API versions: `2017-11-01-preview`. Use crate feature `package-2017-11-01-preview-only` to enable. The operations will be in the `package_2017_11_01_preview_only` module.
- `package-2017-05-01-preview-only` has 12 operations from 1 API versions: `2017-05-01-preview`. Use crate feature `package-2017-05-01-preview-only` to enable. The operations will be in the `package_2017_05_01_preview_only` module.
- `package-2017-04-01-only` has 13 operations from 1 API versions: `2017-04-01`. Use crate feature `package-2017-04-01-only` to enable. The operations will be in the `package_2017_04_01_only` module.
- `package-2017-03-01-preview-only` has 6 operations from 1 API versions: `2017-03-01-preview`. Use crate feature `package-2017-03-01-preview-only` to enable. The operations will be in the `package_2017_03_01_preview_only` module.
- `package-2016-09-01-only` has 4 operations from 1 API versions: `2016-09-01`. Use crate feature `package-2016-09-01-only` to enable. The operations will be in the `package_2016_09_01_only` module.
- `package-2016-06-only` has 2 operations from 1 API versions: `2016-06-01`. Use crate feature `package-2016-06-only` to enable. The operations will be in the `package_2016_06_only` module.
- `package-2016-03-01-only` has 14 operations from 1 API versions: `2016-03-01`. Use crate feature `package-2016-03-01-only` to enable. The operations will be in the `package_2016_03_01_only` module.
- `package-2015-07-01-only` has 10 operations from 2 API versions: `2014-04-01`, `2015-07-01`. Use crate feature `package-2015-07-01-only` to enable. The operations will be in the `package_2015_07_01_only` module.
- `package-2015-04-01-only` has 16 operations from 2 API versions: `2014-04-01`, `2015-04-01`. Use crate feature `package-2015-04-01-only` to enable. The operations will be in the `package_2015_04_01_only` module.
- `package-2014-04-01-only` has 12 operations from 1 API versions: `2014-04-01`. Use crate feature `package-2014-04-01-only` to enable. The operations will be in the `package_2014_04_01_only` module.